//  "myGL.h"
//    "myGL"


#ifndef MYGL_H
#define MYGL_H

#include <QtOpenGL>
#include <QtGui>

#include "sazerlend.h"

class myGL : public QGLWidget
{
	Q_OBJECT

	public:
                myGL(QObject *p = 0);
		
		void setSazerlend(sazerlend *s);
		
		//----------  
                void draw(void);
                void drawPoint(int x, int y);
                void drawLine(int x1, int y1, int x2, int y2);
                void drawRect(int x1, int y1, int x2, int y2);

	public slots:
                void zoomScene(int zoom);
                void slot_algorythm(void);

	protected:
		//----------  openGL
                void initializeGL();
                void resizeGL(int width, int height);
                void paintGL();
                void showEvent(QShowEvent *event);
                void timerEvent(QTimerEvent *event);

		//----------  
                void mousePressEvent(QMouseEvent *event);
                void mouseReleaseEvent(QMouseEvent *event);
                void mouseMoveEvent(QMouseEvent *event);
                void mouseDoubleClickEvent(QMouseEvent *event);
                void wheelEvent(QWheelEvent *event);
		
		//---------- 
		double trX(double x);														//  ->  
		double trY(double y);														//  ->  
		double trBackX(double x);													//  ->  
		double trBackY(double y);													//  ->  

	private:
		double attachX, attachY;													//   
		double scale, c_x, c_y;														//  
		bool drawCoordinateSystem;
		
		sazerlend *SAZ;
		int xx, yy;
};


#endif	//MYGL_H
