//  "sazerlend.cpp"
//   "sazerlend"


#include "sazerlend.h"
#include "myGL.h"

sazerlend::sazerlend(QObject *p) : QObject(p)
{
	drawer = 0;

        rect.x1 = -150;
        rect.y1 = -100;
        rect.x2 = 150;
        rect.y2 = 100;
}

sazerlend::~sazerlend()
{

}

void sazerlend::setDrawer(myGL *d)
{
        drawer = d;
}

void sazerlend::setRect(int x1, int y1, int x2, int y2)
{
    if(x1 <= x2)
    {
        rect.x1 = x1;
        rect.x2 = x2;
    }
    else
    {
        rect.x1 = x2;
        rect.x2 = x1;
    }
    if(y1 <= y2)
    {
	rect.y1 = y1;
	rect.y2 = y2;
    }
    else
    {
        rect.y1 = y2;
        rect.y2 = y1;
    }
    qDebug() << "Set Rect";
}

void sazerlend::setLine(int x1, int y1, int x2, int y2)
{
	line.x1 = x1;
	line.y1 = y1;
	line.x2 = x2;
	line.y2 = y2;	
}

void sazerlend::draw(void)
{
        qDebug() << "Rect:" << rect.x1 << "," << rect.y1 << "," << rect.x2 << "," << rect.y2;
        qDebug() << "Line:" << line.x1 << "," << line.y1 << "," << line.x2 << "," << line.y2;
        drawer -> drawRect(rect.x1, rect.y1, rect.x2, rect.y2);
	drawer -> drawLine(line.x1, line.y1, line.x2, line.y2);
}

void sazerlend::startAlgorythm(void)
{
    int xx, yy, codecode;

    // 1
    qDebug() << tr("1 - Отмечаем коды концов отрезка");
    line.code1 = setCode(line.x1, line.y1);
    line.code2 = setCode(line.x2, line.y2);

    // 2
    if((line.code1 == 0) && (line.code2 == 0))
    {
        qDebug() << tr("2 - Отрезок лежит полностью в прямоугольнике");
        return;
    }

    // 3
    if(line.code1 & line.code2)
    {
        qDebug() << tr("3 - Отрезок лежит вне прямоугольника");
        line.x2 = line.x1;
        line.y2 = line.y1;
        return;
    }

    // 4
    if(!line.code1)
    {
        qDebug() << tr("4 - Переворачиваем отрезок");
        xx = line.x1;
        yy = line.y1;
        codecode = line.code1;
        line.x1 = line.x2;
        line.y1 = line.y2;
        line.code1 = line.code2;
        line.x2 = xx;
        line.y2 = yy;
        line.code2 = codecode;
    }

    // 5
    if(line.code1 == 0x02 || line.code1 == 0x03 || line.code1 == 0x06)
    {
        qDebug() << tr("5 - Обрезаю низ");
        yy = rect.y1;
        xx = line.x1 + (line.x2 - line.x1) * (rect.y1 - line.y1) / (line.y2 - line.y1);
        line.x1 = xx;
        line.y1 = yy;
    }
    else if(line.code1 == 0x09 || line.code1 == 0x08 || line.code1 == 0x0c)
    {
        qDebug() << tr("5 - Обрезаю верх");
        yy = rect.y2;
        xx = line.x1 + (line.x2 - line.x1) * (rect.y2 - line.y1) / (line.y2 - line.y1);
        line.x1 = xx;
        line.y1 = yy;
    }
    else if(line.code1 == 0x01)
    {
        qDebug() << tr("5 - Обрезаю левую часть");
        xx = rect.x1;
        yy = line.y1 + (line.y2 - line.y1) * (rect.x1 - line.x1) / (line.x2 - line.x1);
        line.x1 = xx;
        line.y1 = yy;
    }
    else if(line.code1 == 0x04)
    {
        qDebug() << tr("5 - Обрезаю правую часть");
        xx = rect.x2;
        yy = line.y1 + (line.y2 - line.y1) * (rect.x2 - line.x1) / (line.x2 - line.x1);
        line.x1 = xx;
        line.y1 = yy;
    }
    else
    {
        qDebug() << "Unknown point code found: " << line.code1;
    }

    startAlgorythm();
}

int sazerlend::setCode(int x, int y)
{
    int code;

    code = 0;
    if(x < rect.x1)
        code |= 0x01;
    if(y < rect.y1)
        code |= 0x02;
    if(x > rect.x2)
        code |= 0x04;
    if(y > rect.y2)
        code |= 0x08;

    return code;
}
